import { getValidationClasses } from "../sharedFunctions";

if (typeof angular !== 'undefined') {
    angular.module('mobile-app').component('axfileupload', {
        template: require("./ax-file-upload.html"),
        bindings: {
            instance: '<',
        },
        controller: function ($scope, $camera, $label, $accessibility) {
            this.instance.setCamera($camera);
            this.instance.$accessibility = $accessibility;
            $scope.$this = this.instance;
            $scope.$label = $label;
            $scope.updateUI = function () {
                $scope.$apply();
            };

            $scope.getValidationClasses = getValidationClasses;

            $scope.loadFromDevice = function (useCamera) {
                if ($scope.$this.canLoadFromDevice()) {
                    var options = {
                        quality: 75,
                        destinationType: Camera.DestinationType.FILE_URL,
                        sourceType: !useCamera ? Camera.PictureSourceType.PHOTOLIBRARY : Camera.PictureSourceType.CAMERA,
                        encodingType: Camera.EncodingType.JPEG,
                        targetWidth: 1000,
                        targetHeight: 1000,
                        correctOrientation: true,
                    };
                    $scope.$this.getImage(options).then($scope.updateUI);
                }
            };
        }
    });
}