import * as angular from "angular";
import { Image } from "../../../src/view-model/Control/Image/Image";
import * as Design from "../../../src/view-model/design";
interface IImageScope extends angular.IScope {
    $this: Image;
    getsizingStyles: () => Design.ISizingStyles;
    getSymbolClasses: () => string[];
    getPlaceholderClasses: () => string[];
}

angular.module("mobile-app").component("axImage", {
    template: require("./ax-image.html"),
    bindings: {
        instance: "<",
    },
    controller: function ($scope: IImageScope, connector: any) {
        $scope.$this = this.instance;
        this.instance.setScope && this.instance.setScope($scope); // Pass scope to the image
        let design = this.instance.getDesign();
        $scope.$this.setBaseURL(connector.getBaseUrl());
        $scope.getsizingStyles = function (): Design.ISizingStyles {
            let sizingStyles;
            if (design) {
                if ($scope.$this.imageView === "symbol") {
                    sizingStyles = { fontSize: design.height + "em" };
                } else {
                    sizingStyles = Design.getInlineSizingStyles($scope.$this.getDesign());
                }
            }
            return sizingStyles;
        };

        $scope.getPlaceholderClasses = function (): string[] {
            let placeholderClasses = ["ax-image-placeholder"];
            if ($scope.$this.imageView === "symbol") {
                let symbolPlaceHolderClass = "ax-image-placeholder-" + $scope.$this.placeholderClass;
                placeholderClasses.push(symbolPlaceHolderClass);
            }
            return placeholderClasses;
        };

        $scope.getSymbolClasses = function (): string[] {
            let symbolClasses = ["ax-image-symbol", $scope.$this.symbol];
            if ($scope.$this.imageView === "symbol") {
                if (design && design.height) {
                    symbolClasses.push("ax-image-symbol-size-custom");
                }
            }
            return symbolClasses;
        };
    }
});
