import { getValidationClasses } from "../sharedFunctions";

if (typeof angular !== 'undefined') {
    angular.module('mobile-app').component('barcode', {
        bindings: {
            instance: '<',
        },
        controller: function ($scope, $stateParams, $state, $cordovaBarcodeScanner) {
            $scope.$this = this.instance;
            $scope.getSetFormattedValue = function (value) {
                if (value === undefined) {
                    return $scope.$this.getValue();
                }
                else {
                    $scope.$this.setValue(value)
                }
            }

            $scope.getValidationClasses = getValidationClasses;

            $scope.isInDebug = !window.cordova;

            $scope.scanBarcode = function () {
                $cordovaBarcodeScanner.scan().then(
                    function (result) {
                        if (result && !result.cancelled) {
                            $scope.getSetFormattedValue(result.text);
                        }
                    },
                    function (error) {
                        console && console.log("Barcode scan error: " + error);
                    });
            };
        },
        templateUrl: 'components/barcode/barcode.html',
    });
}
