// tslint:disable:no-string-literal
import { IControl } from "../../../src/view-model/Control/BaseControl/IControl";

let registeredComponents: { [key: string]: string; } = {};

export const registerAllRendererComponents = function (resetRegistration: boolean = true): void {
    if (resetRegistration) {
        registeredComponents = {};
    }

    registeredComponents["InputField"] = "inputfield";
    registeredComponents["Barcode"] = "barcode";
    registeredComponents["Input"] = "field";
    registeredComponents["Real"] = "field";
    registeredComponents["MultilineInput"] = "field";
    registeredComponents["Integer"] = "field";
    registeredComponents["Int64"] = "field";
    registeredComponents["Date"] = "field";
    registeredComponents["DateTime"] = "field";
    registeredComponents["ComboBox"] = "field";
    registeredComponents["Lookup"] = "lookup";
    registeredComponents["MultiLookup"] = "multilookup";
    registeredComponents["Image"] = "ax-image";
    registeredComponents["Navigation"] = "pagelink";
    registeredComponents["FileUpload"] = "axfileupload";
    registeredComponents["Hyperlink"] = "hyperlink";
    registeredComponents["List"] = "list";
    registeredComponents["Calendar"] = "calendar";
    registeredComponents["Group"] = "group";
    registeredComponents["Part"] = "part";
    registeredComponents["Timer"] = "timer";
};

export const getType = function (instance: IControl): string {
    let metadata = instance.metadata();
    let type = registeredComponents[metadata.ExtType];
    if (!type) {
        type = registeredComponents[metadata.Type];
    }
    if (!type) {
        type = metadata.Type;
    }
    if (instance.isEditable() && type === "field") {
        const editableType = "InputField";
        type = registeredComponents[editableType];
    }
    return type;
};