import { getValidationClasses } from "../sharedFunctions";
if (typeof angular !== 'undefined') {
    angular.module('mobile-app').component('inputfield', {
        bindings: {
            instance: '<',
        },
        controller: function($scope) {
            $scope.$this = this.instance;
            $scope.getSetFormattedValue = function(value) {
                if (value !== undefined) {
                    $scope.$this.setEditableValue(value)
                }
                else {
                    return $scope.$this.getEditableFormattedValue();
                }
            }
            $scope.getValidationClasses = getValidationClasses;
            $scope.getInputTypeForField = function(field) {
                let type = field.Type;
                switch (field.Type) {
                    case "Real":
                    case "Int64":
                    case "Integer":
                        type = "number";
                        break;
                    case "Input":
                        type = "text";
                        break;
                    case "DateTime":
                        type = "datetime-local";
                        break;
                    case "Date":
                        type = "date";
                        break;
                    default:
                        type = "text";
                        break;
                }
                return type;
            };
            // Used by renderer to fallback to input control if no enum options have been defined for ComboBox
            $scope.comboBoxHasOptions = function(fieldMetadata) {
                if (!fieldMetadata.bindings.options || !fieldMetadata.bindings.options.length) {
                    return false;
                } else {
                    return true;
                }
            };
        },
        template: require("./inputField.html"),
    });
}

