import * as Design from "../../../src/view-model/design";

if (typeof angular !== 'undefined') {
    angular.module('mobile-app').component('list', {
        template: require('./list.html'),
        bindings: {
            instance: '<',
        },
        controller: function ($scope, $label, $navigate, $ionicPopover, $rootScope, $accessibility) {
            this.instance.$accessibility = $accessibility;
            $scope.$this = this.instance;
            $scope.$label = $label;
            $scope.$navigate = $navigate;
            $scope.styles = Design.getFlexStyles(this.instance.getDesign());
            var popOverObject = $ionicPopover.fromTemplate(require('./searchColumn.html'), {
                scope: $scope
            });

            $scope.openPopover = function ($event) {
                popOverObject.show($event);
            };

            const parentPage = $scope.$this.root();
            if (parentPage) {
                parentPage.onClose.subscribe(function onClose() {
                    popOverObject.hide().then(function () {
                        popOverObject.remove();
                    });
                });
            }

            $scope.closePopover = function () {
                popOverObject.hide();
            };

            $scope.showArrow = function () {
                return $scope.$this.allowsNavigation() && (!$scope.$this.getDesign() || !$scope.$this.getDesign().hideArrow);
            };

            $scope.updateUI = function () {
                $scope.$apply();
            };

            $scope.showEmptyMessage = () => {
                return (!$scope.$this.hideEmptyListMessage && $scope.$this.isListEmpty && !$scope.$this.isLoadingData);
            }

            $scope.showLoadingMessage = () => {
                // show a loading message when the list loads initially
                return (!$scope.$this.hideEmptyListMessage && $scope.$this.isListEmpty && $scope.$this.isLoadingData);
            }
        }
    });
}