import {
    getValidationClasses
} from "../sharedFunctions";

if (typeof angular !== 'undefined') {
    angular.module('mobile-app').component('lookup', {
        bindings: {
            instance: '<',
        },
        template: require("./lookup-control.html"),
        controller: function ($scope, $label, $page, $pageModal) {
            $scope.$this = this.instance;

            $scope.getValue = function () {
                return $scope.$this.getValue();
            };

            $scope.getDisplayValue = function () {
                return $scope.$this.getDisplayValue();
            };

            $scope.getAccessibleName = function () {
                return $scope.$this.getAccessibleName();
            };

            $scope.$this.onDataChanged.subscribe(function () {
                $scope.$apply();
            });

            $scope.getValidationClasses = getValidationClasses;

            $scope.isDisabled = function () {
                return ($scope.$this.metadata().ContextRequired && !$scope.$this.metadata().FilterContext) || $scope.lookupPageIsLoading
            }
            let lookupPageOpen = false;

            $scope.expandedState = false;

            $scope.openLookupPage = function () {
                if (lookupPageOpen) {
                    return;
                }
                let popOverObject;
                $scope.expandedState = true;
                lookupPageOpen = true;
                const lookupPage = $scope.$this.getLookupPage();
                let childScope = $scope.$new();
                childScope.page = lookupPage;
                childScope.$label = $label;

                lookupPage.onClose.subscribe(function onClose() {
                    $scope.expandedState = false;
                    popOverObject.hide().then(function () {
                        popOverObject.remove();

                        lookupPageOpen = false;
                    });
                });

                $scope.lookupPageIsLoading = true;

                $pageModal.fromTemplateUrl('components/lookup-page/lookup-page.html', {
                    scope: childScope,
                    hardwareBackButtonClose: true,
                    useDefaultStatusBar: false
                }).then(function (popover) {
                    popOverObject = popover;
                    popOverObject.show().then(() => {
                        $scope.lookupPageIsLoading = false;
                    });
                });

                childScope.$on('modal.hidden', function () {
                    childScope.page.close();
                    $scope.expandedState = false;
                    lookupPageOpen = false;
                });

                $page.linkFormState(childScope, lookupPage);
            }
        }
    });
}