import * as Design from "../../../src/view-model/design";
import { getClassesForIconName } from "../../js/icon-map";

if (typeof angular !== 'undefined') {
    angular.module('mobile-app').component('pagelink', {
        template: require("./pagelink.html"),
        bindings: {
            instance: '<',
        },
        controller: function ($scope, $navigate, $label) {
            $scope.$this = this.instance;
            $scope.$navigate = $navigate;
            $scope.$label = $label;
            $scope.labelStyles = Design.getStyleClasses(this.instance.getLabelDesign());
            $scope.$this.getAccessibilityLabel = this.instance.getAccessibilityLabel;

            // Watch icon size
            $scope.$watch(function () {
                if (this && this.instance) {
                    return this.instance.getDesignProperty("iconSize") || this.instance.getDesignProperty("height");
                }
            },
                function (iconSize) {
                    $scope.iconBackgrounStyles = Design.getInlineSizingStyles({ height: iconSize, width: iconSize });
                    $scope.iconSymbolStyles = Design.getIconSizingStyles(iconSize / 3.0);
                });

            $scope.getClassesForIcon = function () {
                return getClassesForIconName($scope.$this.metadata().Icon);
            };
            $scope.$this.countLoaded.then(function () {
                $scope.$apply();
            });

            $scope.showArrow = function () {
                let showArrow;
                const instance = $scope.$this;
                if (instance.metadata().Style !== "inline") { //For inline there is no arrow in template
                    if (instance.getDesign() && instance.getDesign().hideArrow) {
                        showArrow = false;
                    }
                    else if (instance.metadata().Style == "button") {
                        showArrow = instance.showCount() && instance.getCount() !== undefined && instance.getCount() !== instance.countPlaceholder;
                    } else {
                        showArrow = instance.allowsNavigation();
                    }
                }
                return showArrow;
            };
        }
    });
}