import * as chai from "chai";
let expect = chai.expect;
import * as angular from "angular";
import { ngMock } from "./../../../src/ngMock";
import "./pull-to-refresh";

describe("Component: pull-to-refresh", function () {
    let element;
    let scope;
    let elementScope;

    beforeEach(() => {
        ngMock.module("mobile-app");
    });

    const compileElementWithScope = ngMock.inject(($rootScope, $compile) => {
        scope = $rootScope.$new();
        element = angular.element('<div class="allow-scroll" pull-to-refresh on-refresh="doRefresh()"></div>');
        element = $compile(element)(scope);
        elementScope = element.children().scope();
        scope.$apply();
    });

    describe("controller", function () {
        beforeEach(function () {
            compileElementWithScope();
        });

        it("should prepend refresh elements to the div", function () {
            const refreshArrow = angular.element(element[0].querySelector(".refresh"));
            const spinner = element.find("ion-spinner");
            expect(refreshArrow).to.not.be.undefined;
            expect(spinner).to.not.be.undefined;
        });
    });

    // TODO: Add more tests
});
