import * as chai from "chai";
let expect = chai.expect;
import { getValidationClasses, InputControlScope } from "./sharedFunctions";
import { IInputControl } from "../../src/view-model/Control/BaseControl/IInputControl";

class TestInputControlScope implements InputControlScope {
    $this: IInputControl;
    getValidationClasses = getValidationClasses;
}

describe("Shared Functions", function () {
    describe("getValidationClasses", function () {
        it("should return an empty array if control is valid", () => {
            let inputControl = new TestInputControlScope();
            inputControl.$this = <any>{
                isValid: true
            };
            expect(inputControl.getValidationClasses()).to.be.empty;
        });
        it("should return correct classes array if control is invalid", () => {
            let inputControl = new TestInputControlScope();
            inputControl.$this = <any>{
                isValid: false
            };
            expect(inputControl.getValidationClasses()).to.not.be.empty;
            expect(inputControl.getValidationClasses()).to.include("statusMandatory");
        });
    });
});