/* map ionic icons to dynamics 365 icons */
const iconMap = new Map<string, string>();
iconMap.set("checkmark", "Checkmark");
iconMap.set("trash-b", "Trash");
iconMap.set("edit", "Edit");
iconMap.set("plus", "New");

/* Use the D365 icons, preferably, but if neccessary, use the ionic icons */
export function getClassesForIconName(icon: string): string {
    if (!icon) {
        return undefined;
    }
    if (icon[0].toUpperCase() === icon[0]) {
        return(icon + "-symbol symbol");
    } else {
        console.warn("Deprecated icon name, '" + icon + "', in use. Please check the Dynamics365 Wiki for a comprehensive list of supported icons. " +
                     "https://github.com/Microsoft/Dynamics365-for-Operations-mobile-FleetManagementSamples/wiki/Navigation.icon");
        if (iconMap.has(icon)) {
            return(iconMap.get(icon) + "-symbol symbol");
        } else {
            return("ion-" + icon);
        }
    }
}